-- Filename:     kookwekker_counter.vhd
-- Filetype:     VHDL Hardware Description
-- Date:         <The Date>
-- Update:       -
-- Description:  Description of a kookwekker counter
-- Author:       <My Name>
-- State:        Production
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2017, <Your Company>

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity kookwekker_counter is
    port (
        clk_32768  : in std_logic; 
        areset     : in std_logic; 
        mins_up    : in std_logic; 
        secs_up    : in std_logic; 
        countdown  : in std_logic;
        clear      : in std_logic;
        tens_mins  : out unsigned(3 downto 0);
        mins       : out unsigned(3 downto 0);
        tens_secs  : out unsigned(3 downto 0);
        secs       : out unsigned(3 downto 0);
        time_zero  : out std_logic
       );
end entity kookwekker_counter;

architecture rtl of kookwekker_counter is
begin

    -- Oops, some code still there...
    process (clk, areset, seconds, tens_seconds, minutes, tens_minutes) is
    begin
        if areset = '1' then
            -- Please add your code here...
        elsif rising_edge(clk_32768) then
            if clear = '1' then
                -- Please add your code here...
            elsif mins_up = '1' then
                -- Please add your code here...
            elsif secs_up = '1' then
                -- Please add your code here...
            elsif countdown = '1' then
                -- Please add your code here...
            end if;
        end if;
        -- time's up. counter at all zero
        if seconds = "0000" and tens_seconds = "0000" and minutes = "0000" and tens_minutes = "0000" then
            time_zero <= '1';
        else
            time_zero <= '0';
        end if;
    end process;
 
end rtl;
